/*
    yamm, Yet Another Micro Monitor
    pstat.c.HPUX
    Copyright (C) 1992  Andrea Marangoni
    Copyright (C) 1994, 1995  Riccardo Facchetti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * Avoid to compile this file with -Aa option of cc for ANSI mode
 * There are some problems whith pstat system call
 * Avoid to compile this file with gcc
 * Thank to Mike Peterson (root@alchemy.chem.utoronto.ca) to clear
 * gcc bugs
 */

#include "yamm.h"

int PS_proc ( struct pst_status *bpbuf, int num_proc, int index )
{
	int real_procs;
	union pstun pstatbuf;

/*
 * Allocate here the process array, if not yet allocated
 */
	if (!pbuf)
		pbuf = (struct pst_status * )malloc(
										sizeof(struct pst_status) * MAX_PROC);
	if (num_proc) {
		pstatbuf.pst_status = pbuf;
		real_procs = pstat( PSTAT_PROC, pstatbuf, sizeof(struct pst_status),
				num_proc, index );
		return real_procs;
	}
	else {
#define BUF ((struct pst_status *)bpbuf)
		pstatbuf.pst_status = BUF;
		return ( pstat(PSTAT_PROC, pstatbuf, sizeof(struct pst_status),
			num_proc, index) );
	}
#undef BUF
}

void PS_dynam ( struct pst_dynamic *dinfo )
{
	union pstun pstatbuf;
	pstatbuf.pst_dynamic = dinfo;
	if ( pstat ( PSTAT_DYNAMIC, pstatbuf,  sizeof (struct pst_dynamic), NULL,NULL ) == -1 )
		( void )perror ( "Pstat: PSTAT_DYNAMIC" ),exit ( 1 );
}

void PS_stat ( struct pst_static *sinfo )
{
	union pstun pstatbuf;
	pstatbuf.pst_static = sinfo;
	if ( pstat ( PSTAT_STATIC, pstatbuf,  sizeof (struct pst_static), NULL, NULL) == -1)
		( void )perror ( "pstat: PSTAT_STATIC" ), exit ( 1 );
}

void PS_vm ( struct pst_vminfo *vinfo )
{
	union pstun pstatbuf;
	pstatbuf.pst_status = ( struct pst_status *)vinfo;
	if ( pstat ( PSTAT_VMINFO, pstatbuf, sizeof (struct pst_vminfo), NULL, NULL) == -1)
		( void )perror ( "Pstat: PSTAT_VMINFO" ), exit ( 1 );
}
